version: 2.1

jobs:
  run_tests:
    docker:
      - image: circleci/node:14

    steps:
      - checkout
  
      - run:
          name: Install Dependencies
          command: npm install

      - run:
          name: Run tests
          command: npm test

  build_and_publish:
    docker:
      - image: circleci/node:14

    steps:
      - checkout

      - setup_remote_docker

      - run:
          name: Build Docker Image
          command: |
            docker build -t aryan523/nodejs-demoapp:latest .

      - run:
          name: Push Docker Image
          command: |
            echo "$DOCKER_PASSWORD" | docker login -u "$DOCKER_USERNAME" --password-stdin
            docker push aryan523/nodejs-demoapp:latest

workflows:
  version: 2
  build_test:
    jobs:
      - run_tests
      - build_and_publish
